Index: /pjproject/trunk/tests/automated/configure.py
===================================================================
--- /pjproject/trunk/tests/automated/configure.py	(revision 3299)
+++ /pjproject/trunk/tests/automated/configure.py	(revision 3300)
@@ -13,4 +13,6 @@
 vs_target = ""
 s60_target = ""
+no_test = False
+no_pjsua_test = False
 
 #
@@ -124,5 +126,5 @@
 
 def replace_vars(text):
-	global vs_target, s60_target, build_type
+	global vs_target, s60_target, build_type, no_test, no_pjsua_test
 	suffix = ""
 
@@ -173,10 +175,13 @@
         while True:
                 if text.find("$(PJSUA-TESTS)") >= 0:
-			# Determine pjsua exe to use
-			exe = "../../pjsip-apps/bin/pjsua-" + suffix
-                        proc = subprocess.Popen(PYTHON + " runall.py --list-xml -e " + exe, 
-						cwd="../pjsua",
-                                                shell=True, stdout=subprocess.PIPE)
-                        content = proc.stdout.read()
+			if no_test==False and no_pjsua_test==False:
+				# Determine pjsua exe to use
+				exe = "../../pjsip-apps/bin/pjsua-" + suffix
+				proc = subprocess.Popen(PYTHON + " runall.py --list-xml -e " + exe, 
+							cwd="../pjsua",
+							shell=True, stdout=subprocess.PIPE)
+				content = proc.stdout.read()
+			else:
+				content = ""
                         text = text.replace("$(PJSUA-TESTS)", content)
                 elif text.find("$(GCC)") >= 0:
@@ -228,4 +233,10 @@
 				cmd = "echo Success"
                         text = text.replace("$(NOP)", cmd)
+                elif text.find("$(NOTEST)") >= 0:
+			if no_test:
+				str = '"1"'
+			else:
+				str = '"0"'
+                        text = text.replace("$(NOTEST)", str)
                 else:
                         break
@@ -234,5 +245,5 @@
 
 def main(args):
-	global vs_target, s60_target, build_type
+	global vs_target, s60_target, build_type, no_test, no_pjsua_test
         output = sys.stdout
         usage = """Usage: configure.py [OPTIONS] scenario_template_file
@@ -256,4 +267,6 @@
 			    - "gcce udeb"
 			    - "gcce urel"
+  -notest               Disable all tests in the scenario.
+  -nopjsuatest          Disable pjsua tests in the scenario.
 """
 
@@ -295,4 +308,10 @@
 				sys.stderr.write("Error: invalid -t argument value\n")
 				sys.exit(1)
+		elif args[0]=='-notest' or args[0]=='-notests':
+			args.pop(0)
+			no_test = True
+		elif args[0]=='-nopjsuatest' or args[0]=='-nopjsuatests':
+			args.pop(0)
+			no_pjsua_test = True
 		else:
 			break
Index: /pjproject/trunk/tests/automated/gnu-ipp.xml.template
===================================================================
--- /pjproject/trunk/tests/automated/gnu-ipp.xml.template	(revision 3299)
+++ /pjproject/trunk/tests/automated/gnu-ipp.xml.template	(revision 3300)
@@ -19,9 +19,9 @@
 		<Configure cmd='./aconfigure --enable-ipp --with-ipp="$(IPPROOT)" --with-ipp-samples="$(IPPSAMPLES)" --with-ipp-arch=$(IPPARCH)' />
 		<Build cmd="make dep &amp;&amp; make clean &amp;&amp; make" />
-		<Test name="pjlib-test" wdir="pjlib/bin" cmd="./pjlib-test-$(SUFFIX)" />
-		<Test name="pjlib-util-test" wdir="pjlib-util/bin" cmd="./pjlib-util-test-$(SUFFIX)" />
-		<Test name="pjnath-test" wdir="pjnath/bin" cmd="./pjnath-test-$(SUFFIX)" />
-		<Test name="pjmedia-test" wdir="pjmedia/bin" cmd="./pjmedia-test-$(SUFFIX)" />
-		<Test name="pjsip-test" wdir="pjsip/bin" cmd="./pjsip-test-$(SUFFIX)" />
+		<Test name="pjlib-test" wdir="pjlib/bin" cmd="./pjlib-test-$(SUFFIX)" disabled=$(NOTEST) />
+		<Test name="pjlib-util-test" wdir="pjlib-util/bin" cmd="./pjlib-util-test-$(SUFFIX)" disabled=$(NOTEST) />
+		<Test name="pjnath-test" wdir="pjnath/bin" cmd="./pjnath-test-$(SUFFIX)" disabled=$(NOTEST) />
+		<Test name="pjmedia-test" wdir="pjmedia/bin" cmd="./pjmedia-test-$(SUFFIX)" disabled=$(NOTEST) />
+		<Test name="pjsip-test" wdir="pjsip/bin" cmd="./pjsip-test-$(SUFFIX)" disabled=$(NOTEST) />
 		$(PJSUA-TESTS)
 	</Submit>
Index: /pjproject/trunk/tests/automated/gnu.xml.template
===================================================================
--- /pjproject/trunk/tests/automated/gnu.xml.template	(revision 3299)
+++ /pjproject/trunk/tests/automated/gnu.xml.template	(revision 3300)
@@ -19,9 +19,9 @@
 		<Configure cmd="./aconfigure" />
 		<Build cmd="make dep &amp;&amp; make clean &amp;&amp; make" />
-		<Test name="pjlib-test" wdir="pjlib/bin" cmd="./pjlib-test-$(SUFFIX)" />
-		<Test name="pjlib-util-test" wdir="pjlib-util/bin" cmd="./pjlib-util-test-$(SUFFIX)" />
-		<Test name="pjnath-test" wdir="pjnath/bin" cmd="./pjnath-test-$(SUFFIX)" />
-		<Test name="pjmedia-test" wdir="pjmedia/bin" cmd="./pjmedia-test-$(SUFFIX)" />
-		<Test name="pjsip-test" wdir="pjsip/bin" cmd="./pjsip-test-$(SUFFIX)" />
+		<Test name="pjlib-test" wdir="pjlib/bin" cmd="./pjlib-test-$(SUFFIX)" disabled=$(NOTEST) />
+		<Test name="pjlib-util-test" wdir="pjlib-util/bin" cmd="./pjlib-util-test-$(SUFFIX)" disabled=$(NOTEST) />
+		<Test name="pjnath-test" wdir="pjnath/bin" cmd="./pjnath-test-$(SUFFIX)" disabled=$(NOTEST) />
+		<Test name="pjmedia-test" wdir="pjmedia/bin" cmd="./pjmedia-test-$(SUFFIX)" disabled=$(NOTEST) />
+		<Test name="pjsip-test" wdir="pjsip/bin" cmd="./pjsip-test-$(SUFFIX)" disabled=$(NOTEST) />
 		$(PJSUA-TESTS)
 	</Submit>
Index: /pjproject/trunk/tests/automated/msvc.xml.template
===================================================================
--- /pjproject/trunk/tests/automated/msvc.xml.template	(revision 3299)
+++ /pjproject/trunk/tests/automated/msvc.xml.template	(revision 3300)
@@ -9,13 +9,14 @@
 #define PJ_HAS_IPV6		1
 #define PJMEDIA_HAS_G7221_CODEC 1
+#define PJ_TODO(x)
 ]]>			
 		</FileWrite>
 		<Configure cmd="cmd /c echo success" />
 		<Build cmd='vcbuild.exe /nologo /nohtmllog /nocolor /rebuild pjproject-vs8.sln "$(VSTARGET)|Win32"' />
-		<Test name="pjlib-test" info="" wdir="pjlib/bin" cmd="pjlib-test-i386-Win32-vc8-$(VSTARGET)" />
-		<Test name="pjlib-util-test" info="" wdir="pjlib-util/bin" cmd="pjlib-util-test-i386-Win32-vc8-$(VSTARGET)" />
-		<Test name="pjnath-test" info="" wdir="pjnath/bin" cmd="pjnath-test-i386-Win32-vc8-$(VSTARGET)" />
-		<Test name="pjmedia-test" info="" wdir="pjmedia/bin" cmd="pjmedia-test-i386-Win32-vc8-$(VSTARGET)" />
-		<Test name="pjsip-test" info="" wdir="pjsip/bin" cmd="pjsip-test-i386-Win32-vc8-$(VSTARGET)" />
+		<Test name="pjlib-test" info="" wdir="pjlib/bin" cmd="pjlib-test-i386-Win32-vc8-$(VSTARGET)" disabled=$(NOTEST)/>
+		<Test name="pjlib-util-test" info="" wdir="pjlib-util/bin" cmd="pjlib-util-test-i386-Win32-vc8-$(VSTARGET)" disabled=$(NOTEST) />
+		<Test name="pjnath-test" info="" wdir="pjnath/bin" cmd="pjnath-test-i386-Win32-vc8-$(VSTARGET)" disabled=$(NOTEST) />
+		<Test name="pjmedia-test" info="" wdir="pjmedia/bin" cmd="pjmedia-test-i386-Win32-vc8-$(VSTARGET)" disabled=$(NOTEST) />
+		<Test name="pjsip-test" info="" wdir="pjsip/bin" cmd="pjsip-test-i386-Win32-vc8-$(VSTARGET)" disabled=$(NOTEST) />
 		$(PJSUA-TESTS)
 	</Submit>
Index: /pjproject/trunk/tests/automated/prepare.xml.template
===================================================================
--- /pjproject/trunk/tests/automated/prepare.xml.template	(revision 3299)
+++ /pjproject/trunk/tests/automated/prepare.xml.template	(revision 3300)
@@ -28,4 +28,12 @@
 		<Test name="Configuring iPhone scenario" cmd="python configure.py -t gnu -o iphone.xml iphone.xml.template" />
 
+		<!-- MSVC target.
+		     Requirements:
+		      - Build from VS successfully
+		      - VS paths are set
+
+		 -->
+		<Test name="Configuring Visual Studio for Win32" cmd="python configure.py -t vs -vstarget Release -o msvc-win32.xml -nopjsuatest msvc.xml.template" />
+
 		<!-- Symbian target.
 		     Requirement:
Index: /pjproject/trunk/tests/automated/testvars.template
===================================================================
--- /pjproject/trunk/tests/automated/testvars.template	(revision 3299)
+++ /pjproject/trunk/tests/automated/testvars.template	(revision 3300)
@@ -7,4 +7,5 @@
 PJDIR = 	"$(PJDIR)"
 SUFFIX = 	"$(SUFFIX)"
+NOTEST = 	"$(NOTEST)"
 
 S60 only:
@@ -12,4 +13,6 @@
 S60TARGET = 	"$(S60TARGET)"
 S60TARGETNAME = "$(S60TARGETNAME)"
+S60DEVICE = 	"$(S60DEVICE)"
+EPOCROOT = 	"$(EPOCROOT)"
 
 VS only:
@@ -23,2 +26,8 @@
 ------------------------------
 
+OTHER:
+------------------------------
+IPPROOT
+IPPSAMPLES
+IPPARCH
+NOP (cmdline to do nothing)